#include "pmode.h"
#include "interupt.h"
#include "memorypm.h"
#include "console.h"
#include "inpoutp.h"
#include "debug.h"
#include "logdump.h"

#include <stdlib.h> // ??? 

#define readfw Far_Read_Word(SELECTOR::GLOBAL_MEMORY_RO

struct BACK_DOOR_INFO BackDoorInfo;

/*

struct SAVE_SEGMENT_AND_32BIT_REGISTER
{
	WORD SS, CS,
		 GS, FS,
		 ES, DS;
	DWORD EDI, ESI, EBP, ESP, EBX, EDX, ECX, EAX;
};

*/

//믮塞   ࢠ 
void BACK_DOOR_INFO::execute()
{
for(int i=0; i<20;i++)
	beep(50,1000+i*20);

	need_ret_pm=FALSE;
	WORD cs_reg=CS;
	DWORD eip_reg=EIP;
	DWORD efl=EFLAGS;
	_EDI=EDI;
	_ESI=ESI;
	_EBX=EBX;
	_ECX=ECX;
	_EDX=EDX;
	_DS=DS;
	_FS=FS;
	_GS=GS;
	_ES=ES;
	_ESP=ESP;
	asm push dword ptr efl
	asm push word ptr 0
	asm push word ptr cs_reg
	asm push dword ptr eip_reg

	_EBP=EBP;
	asm iretd
}

extern WINCONSOLE wincon;
extern DWORD Int13HandlerFlag;

extern BYTE TraceMode;

BYTE	Virtual_Hardware_Interrupt=FALSE;
BYTE	int15_TransferBlock(WORD CX_reg, WORD ES_reg, WORD SI_reg);

//४஢ ॣ 䫠
// ,  ᯮ  樨  POPF, POPFD, IRET, IRETD
//㠫쭮 設    䫠 뢠 IF
//  㣨 䫠 ࠢ (TF  ..)
// IOPL ⠪     ࠧ 樮 ⥬
//祭 䫠 VM,RF ।⢮  POPFD
//஬ ⮣,  㭪 ४ 䫠 ஢ ⠪
//ࠧ, ⮡,   VM-  ॢ,   ,
// ( ????)
//   ⠭ 䫠 ஢, ⮡ ᫥ ᫥饩
//  뫮   ⫠稪
WORD VM_Correct_Flags(WORD flag)
{
	if (TraceMode) flag|=256;	//⠭ 䫠 ஢(᫨ 㦭)

	flag&=0xCFFF;	// ⠭ IOPL=0

	// ࠧ蠥 뢠 ( ᪠
	//饭 뢠  㠫쭮 )
	flag|= 512;

	//ᥣ 뢠 䫠 VM  ⠫ 訥 䫠
	//(  ⠥ pushfd/popfd)
	//㧭, 室    V-०
//	eflag&=0xFFFF;

	return flag;
}

#define COM_WRITE		1
#define COM_READ		0

LOGING_DUMP ComBuf;


#define REGS32 SAVE_SEGMENT_AND_32BIT_REGISTER
#define REGS16 SAVE_SEGMENT_AND_16BIT_REGISTER


template <class T>
void Write_outp(WORD ad, T n)
{
	char *ZX[]={ "", "B ","W "};
			ComBuf.Write(ZX[sizeof(T)]);
			ComBuf.WriteNum(ad);
			ComBuf.Write(",");
			ComBuf.WriteNum(n);
			ComBuf.Write("\r\n");

}

BOOL SimulateOUT_DX_AL(REGS16 * RegState16)
{
	if (RegState16->DX == 0x2F8)
	{

			/*WINCONSOLE po(30,10,7," RegState16 ");
				po.Show();
				po<<RegState16->DX<<" press <8>";
					wait_key(7);*/

			//頥  ७ 
		if (ComBuf.rw != COM_WRITE)
		{ComBuf.Write("<OUT>"); ComBuf.rw=COM_WRITE;}
		ComBuf.Write(RegState16->AX);
		}
	else
	{
			ComBuf.Write("B ");
			ComBuf.WriteNum(RegState16->DX);
			ComBuf.Write(",");
			ComBuf.WriteNum(BYTE(RegState16->AX));
			ComBuf.Write("\r\n");
	}

	outp(RegState16->DX, BYTE(RegState16->AX));

	return TRUE;
}



BOOL SimulateOUT_DX_WordAX(REGS16 * RegState16)
{
	if (RegState16->DX == 0x2F8)
	{

			/*WINCONSOLE po(30,10,7," RegState16 ");
				po.Show();
				po<<RegState16->DX<<" press <8>";
					wait_key(7);*/

			//頥  ७ 
		if (ComBuf.rw != COM_WRITE)
		{ComBuf.Write("<OUT dx ax>"); ComBuf.rw=COM_WRITE;}
		ComBuf.Write(RegState16->AX);
		}
	else
	{
			ComBuf.Write("W ");
			ComBuf.WriteNum(RegState16->DX);
			ComBuf.Write(",");
			ComBuf.WriteNum(RegState16->AX);
			ComBuf.Write("\r\n");
	}

	outp_w(RegState16->DX, RegState16->AX);

	return TRUE;
}


BOOL Simulate_IN_AL_DX(REGS16 * RegState16)
{
	//뢠  
	RegState16->AX&=0xFF00;
	BYTE dt=inp(RegState16->DX);
	RegState16->AX+=dt;

	if (RegState16->DX == 0x2F8)
	{
		//頥  ७ 
		if (ComBuf.rw != COM_READ)
		{
			ComBuf.Write("<IN>"); ComBuf.rw=COM_READ;}
			ComBuf.Write(dt);
		}
	return TRUE;
}


//ࠡ⪠ 権, 맢 襭 饩  13(0D)
// 砥 ᯥ ࠡ⪠ 樨,  ⥪  
// ⭮ 砥 - ० 㠫樨 ⫠稪
BYTE DisasmInstruction(WORD inf_addr, DWORD cseip_addr, BYTE Vmode,
REGS32 * RegState)
{
	REGS16 *RegState16= (REGS16 *)RegState;

	BYTE Auto=FALSE;

	WORD *info=(WORD*)inf_addr;
	DWORD *info_dw=(DWORD*)info;

		#define readf Far_Read(SELECTOR::GLOBAL_MEMORY_RO
		wincon<<"OpCode: ";
		BYTE opcode=readf,cseip_addr);
		BYTE opcode_p1=readf,cseip_addr+1);
		BYTE opcode_p2=readf,cseip_addr+2);
		switch (opcode)
		{

			case 0xCC:	//int 3
			{
					WORD vector_ip=readfw, 1*4);
					WORD vector_cs=readfw, 1*4+2);
					Simulate_Push(OLD_SS,OLD_SP-2,OLD_FLAGS);
					Simulate_Push(OLD_SS,OLD_SP-4,OLD_CS);
					Simulate_Push(OLD_SS,OLD_SP-6,OLD_IP);

					OLD_CS=vector_cs;
					OLD_EIP=vector_ip;

					OLD_SP-=6;

					beep(50,4000);
					beep(50,5000);
					beep(50,9000);

					//if (Int13HandlerFlag & INT13HANDLER_VIRTUAL_INT_AUTO)
						Auto=TRUE;
					break;

			}


			case 0xE5:	// in AX,n
			{
				RegState16->AX=inp_w(opcode_p1);
				Auto=TRUE;
				OLD_EIP+=2;
				break;
			}

			case 0xE4: //in /al,N
			{
				RegState16->AX&=0xFF00;
				RegState16->AX|=inp(opcode_p1);
				Auto=TRUE;
				OLD_EIP+=2;
				break;
			}

			case 0xE7: // out n,AX
			{
				outp_w(opcode_p1, RegState16->AX);
				Write_outp(WORD(opcode_p1), RegState16->AX);
				OLD_EIP+=2;
				Auto=TRUE;
				break;
			}

			case 0xE6:	//out n,AL
			{
				outp(opcode_p1, BYTE(RegState16->AX));
				Write_outp(WORD(opcode_p1), BYTE(RegState16->AX));
				OLD_EIP+=2;
				Auto=TRUE;
				break;
			}

			case 0xEC:	//in al,dx
			{
				Auto=Simulate_IN_AL_DX(RegState16);
				OLD_EIP++;
				break;
			}

			case 0xEE:	//out dx,al
			{
				Auto=SimulateOUT_DX_AL(RegState16);
//				beep(50,2000);
				OLD_EIP++;
				break;
			}

			case 0xEF:	//out dx,ax
			{
				Auto=SimulateOUT_DX_WordAX(RegState16);
				//beep(50,1000);
				OLD_EIP++;
				break;
			}


			case 0x2E:

				if (opcode_p1==0x0F && opcode_p2 == 0x01)
				{
					wincon<<"Privel instr CS: 0x0F,0x01,???";
					OLD_EIP+=6;
					break;
				}
			break;


			case 0x0F:
			{
				if (opcode_p1==0x22 || opcode_p1==0x23)
				{
					wincon<<"Privel instruction mov cr0/dr0/tr3";
					OLD_EIP+=3;
					break;
				}

				if (opcode_p1==0x01)
				{
					wincon<<"Privel instruction 0x0F,0x01,???";
					OLD_EIP+=3;
					break;
				}

				if (opcode_p1==0x20 && opcode_p2==0xc0)
				{
					///34 35
					// !   ᫠  ६
					//  34  35 !!!
					//᫨  訢 ﭨ, 頥
					//  16 

				// ⠪.    ॠ஢ ⮫쪮 ᫨
				// 饭  V_०,  ᨣ஢ 䫠 ७
				// 䫠 㫥
				//ࠡ稪 13 뢠 ⠭ 䫠 ७
				// 砥 ࠡ  V-०,  뢠   0
				//P-०
				//। ᮬ ணࠬ   ॣ EAX=0
				//᫨ ணࠬ ࠡ⠥  R-०,   P- 
				//⮭ ஢ ਢ,   EAX 㧨
				//⨭ 祭 ॣ. CR0,  ⨢ 砥 (V-०)
				//ன 13 ᪫祭,  eax  .
				// ࠧ ணࠬ  ஢ ॣ. EAX
				//᫨   - .   ,   CF=1
				// V-mode

					wincon<<"MOV EAX,CR0 =";
					if (Vmode)
					{
						OLD_FLAGS|=1;
						OLD_EIP+=3;
						Auto=TRUE;
					}
				}
				else wincon<<"????";

				break;
			}

			case 0x66:
			{
				if (opcode_p1 == 0xCF) {wincon<<"iretd"; break; }

				if (opcode_p1 !=0x9c) {wincon<<"0x66 ????";break;}
				//頥  ⥪  ॣ 䫠.
				// ! ண
				if (Vmode)
				{
					//  - 㧭 訥  flags!!!
					wincon<<"PUSHFD";
					OLD_SP-=4;
					Simulate_Push_DWord(OLD_SS,OLD_SP,OLD_EFLAGS);
					//Simulate_Push_DWord(OLD_SS,OLD_ESP,0x55779911);
					OLD_EIP+=2;

					if (Int13HandlerFlag & INT13HANDLER_VIRTUAL_PUSHFD_AUTO)
					  Auto=TRUE;
				}
				break;
			}


			case 0x9C:{
				if (Vmode)
				{
				OLD_SP-=2;
				Simulate_Push(OLD_SS,OLD_SP,OLD_FLAGS);
				wincon<<"PUSHF";
				OLD_EIP++;

					if (Int13HandlerFlag & INT13HANDLER_VIRTUAL_PUSHF_AUTO)
						Auto=TRUE;
				}
				break;
			}
//**************************************************************************
//************           POPF                        ****************
//**************************************************************************
			case 0x9D:
			 if(Vmode)
			 {
			   //   xx00 iiii xxxx eeee
			   //   C     F      F   F
				//BYTE old_iopl=OLD_FLAGS & 0xCFFF;
				OLD_FLAGS=VM_Correct_Flags(Simulate_Pop(OLD_SS, OLD_SP));

				//------------------------------
				OLD_SP+=2;
				wincon<<"POPF FL="<<OLD_FLAGS;
				OLD_EIP++;

				if (Int13HandlerFlag & INT13HANDLER_VIRTUAL_POPF_AUTO)
						Auto=TRUE;

			 }
			break;

//================================================================================
//㠫쭠 設 ⠥ 믮  INT ??
			case 0xCD:
			{
				BYTE vn=readf,cseip_addr+1);
				wincon<<"int "<<vn;

				//㦥 ᢮ ࠡ稪 15H ?

				BYTE AH=RegState->EAX >> 8;

/*			BYTE int13_DiskReadWriteOperation(BYTE ah);
				if (Vmode && vn==0x13 && AH==0x03)
				{
				int13_DiskReadWriteOperation(AH);
				}*/
				//if ( Vmode && vn==0x10 && WORD(RegState->EAX)==0x13 )
				//{
				//	Auto=FALSE;
				//}

				if ( Vmode && vn==0x15 && AH==0x87 )
				{
					// ଠ쭮 ?
					if (int15_TransferBlock(RegState->ECX, OLD_ES, RegState->ESI) == TRUE)
					{
						//⠭ 室 ਧ: AH=0, ZF=1, CF=0
						OLD_FLAGS|=64; //ZF=1 (ZR)
						OLD_FLAGS&=0xFFFE; //CF=0 (NC)
						RegState->EAX &= 0xFFFF00FFUL;
							// AH=0 //ᯥ
						// ᫥.  㪠뢠
						OLD_EIP+=2;
						Auto=TRUE;
					}

				}

				else if ( Vmode && vn==0x21 &&
					(RegState->EAX==0xF001 || RegState->EAX==0xF002) )
				{
					// ࠧ  (ecx)
					//  ஢ઠ  㭪 ࠡ⠥
					if (RegState->EAX == 0xF001)
					{
						RegState->ECX= ComBuf.GetCount();
						RegState->EAX=0x11223344UL;	//ᯥ
					}
					//   
					// edx -   Com- P-०
					// fs:DI -  ॠ쭮 ०
					// cx - ᫮   뢠
					else if (RegState->EAX == 0xF002)
					{
						RegState->EAX=ComBuf.Read(RegState->ESI);
					}
						// ᫥.  㪠뢠
						OLD_EIP+=2;
						Auto=TRUE;
				}

				else if (Vmode)
				//ࠨ ⥪   ࠡ⨪ 뢠
				//㠫쭮 ०
				{
					WORD vector_ip=readfw, vn*4);
					WORD vector_cs=readfw, vn*4+2);
					wincon<<" vector="; wincon<<vector_cs<<":"<<vector_ip;

					//ਢ   ⥪ ॠ쭮 ०
				//????????????????   int
					Simulate_Push(OLD_SS,OLD_SP-2,OLD_FLAGS);
					Simulate_Push(OLD_SS,OLD_SP-4,OLD_CS);
					Simulate_Push(OLD_SS,OLD_SP-6,OLD_IP+2);

					OLD_CS=vector_cs;
					OLD_EIP=vector_ip;

					OLD_SP-=6;

					if (Int13HandlerFlag & INT13HANDLER_VIRTUAL_INT_AUTO)
						Auto=TRUE;
				}
				break;
			}
//================================================================================
			case 0xFA: wincon<<"cli";

			// ᫨  ? 㬠,    Vmode != TRUE
			//⢥: ,  CPL<IOPL (  ?:)
			if (Vmode)
				{
					//ਢ   ⥪ ॠ쭮 ०
					OLD_EIP++;

					//!!!!  塞 䫠 뢠 !!!

					//뢠 䫠 뢠  ࠧ ⥪
					OLD_FLAGS&=~512;

					//뢠 䫠 㠫 뢠
					// 砥,  ࠯뢠  
					//㯠  V-
					Virtual_Hardware_Interrupt=FALSE;

				if (Int13HandlerFlag & INT13HANDLER_VIRTUAL_CLI_AUTO)	Auto=TRUE;

				}
			break;
//#############################################################################

			case 0xFB:
			{
				wincon<<"sti";

				if (Vmode)
				{
					//ਢ   ⥪ ॠ쭮 ०
					OLD_EIP++;
					//OLD_FLAGS|=512;

					Virtual_Hardware_Interrupt=TRUE;
					if (Int13HandlerFlag & INT13HANDLER_VIRTUAL_STI_AUTO)
						Auto=TRUE;

				}
			break;
			}


			case 0xCF:
			{
				wincon<<"iret ";
				//᫨  室  . ०, ࠨ
				//⥪ 3    ⥪ 0-  襬  
				//室 ⠫஢  䫠 !!!
				if (Vmode)
				{
					if (BackDoorInfo.need_ret_pm)
					{
						// 㦥  㤥 
						BackDoorInfo.execute();
					}

					wincon<<"Vector:";

//                    Simulate_Push(OLD_SS, OLD_SP, 0x3131);

					DWORD base=DWORD(OLD_SS)*16;
					OLD_IP=readfw, base+OLD_SP   +0);
					OLD_CS=readfw, base+OLD_SP   +2);
					OLD_FLAGS=VM_Correct_Flags(readfw, base+OLD_SP+4));

					OLD_SP+=6;

					wincon<<OLD_CS<<":"<<OLD_EIP<<" ";

					for (int cnt=-4;cnt<8;cnt++)
					{
						if (!cnt) wincon.attrib=7+8;
						else wincon.attrib=7;
						wincon<<
					Far_Read(SELECTOR::GLOBAL_MEMORY_RO , base+OLD_SP+cnt)
						<<" ";

//							beep(20,6000);
//							beep(40,8000);

					}

					if (Int13HandlerFlag & INT13HANDLER_VIRTUAL_IRET_AUTO)
						Auto=TRUE;
				}
				break;
			}
			default: wincon<<"can't disasm";
		}

		wincon<<"\r\n";

		wincon.Enable(TRUE);

		if (OLD_ESP > 0xFFFF || OLD_EIP > 0xFFFF) Auto=FALSE;

		return Auto;

}

//   ⥬
//ࠡ稪 13(0D) ⪠: 襭 饩 
extern "C" void pascal int13()
{
	//䠪᪨     enter N,0
	//( N   ᫠  ६)
	// ⭠ push bp, mov bp,sp sub sp,N ( ;)
	//⮬   楤 ॡ  LEAVE
	// ᫥⥫쭮 BP 㤥 !!!
/*	asm {
		PUSHAD
// PUSHAD  PUSH EAX,ECX,EDX,EBX,室 ESP, EBP, ESI, EDI
//ᥣ 8 ॣ஢ (32 )
		push ds es fs gs
		push cs ss
	}*/
	PUSH_ALL_REGISTER;

	_DS=SELECTOR::DATA;
	_ES=SELECTOR::DATA;

	BYTE Auto=FALSE;

	BYTE *	date;

	date=(BYTE*)			_BP+2;
	WORD *info=(WORD*)		date;
	DWORD *info_dw=(DWORD*)	date;

	WORD Vmode=(date[14]&2)>>1;	//  ०  .  뢠

	WORD ShowDebug=Int13HandlerFlag & INT13HANDLER_SHOWDEBUG;

	wincon.gotoxy(0,0);
	wincon.numberSystem=16;
			wincon.SetCaption(" General Protection Fault - 13 (0D) ");
	if (ShowDebug) wincon.Show();

//	beep(100,6000);
//	beep(100,5000);
//	beep(100,6000);
//	beep(100,7000);

	WORD real_cs=OLD_CS;
	WORD real_eip=OLD_EIP;

//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	DWORD cseip_addr;
	if (Vmode)	cseip_addr=DWORD(OLD_CS)*16 + OLD_EIP;
	else		cseip_addr=GetBase(OLD_CS)  + OLD_EIP;

	SAVE_SEGMENT_AND_32BIT_REGISTER *RegState;
//	if (ShowDebug)
  //	{
		// !   ᫠ 㬥⮢
		//㭪樨 printalllregister
		//  ᫮ 44  㦭
	_BX=(WORD)info;
	_DX=0; //0  㧭 
	asm call PrintAllRegister	//㭪 ᠬ  ⥪ ???
	asm mov RegState,ax
	asm sub sp,44		//  㦭  ⠭ (popad & etc)
//	}

//	wincon<<"#### Reg EH="<< ((RegState->EAX>>8) & 255)<<"\r\n";
	wincon.attrib=2;

	// 뢮 Opcode ...
	if (!ShowDebug) wincon.Enable(FALSE);
	Auto=DisasmInstruction(_BP+2, cseip_addr,Vmode, RegState);
//	Auto=FALSE;		//===========
	if (!Auto) ShowDebug=TRUE;

	wincon.Enable(TRUE);

	if (ShowDebug) SaveTextScreenBuffer();

	_BX=(WORD)info;
	_DX=ShowDebug | PRINT_ERR_CODE_EXIST;
	asm call PrintAllRegister	//㭪 ᠬ  ⥪
	asm mov RegState,ax
	asm sub sp,44		//  㦭  ⠭ (popad & etc)

	if (ShowDebug)
	{
	//	wincon.numberSystem=16;
		wincon.attribReset();
		wincon.Show();
		wincon.gotoxy(0,1);
		wincon.numberSystem=16;
		//wincon<<"N -> "<<++int13count;

		wincon.digitCount=8;
		wincon.numberSystem=16;

		wincon<<"\r\n";
	}

	if (ShowDebug)
	{
		ShowDebugInfo(info,real_cs,real_eip);
	}


if (Auto==0)
{
	pause(1000ul);
	beep(34,7000);
	pause(1000ul);
	beep(24,6000);
}

//	wincon<<"Exit Stack="<<DWORD(_BP+4)<<"\r\n";
if (ShowDebug)
{
	wincon.Line('-');
	wincon<<"<-> <+> correct return EIP\r\n";
	wincon<<"<1> exit, <9> - trace <ESC> iret\r\n";
}
//横  
repeat:
BYTE jjj=0;
  while (!Auto)
  {
	++jjj&=15;
	wincon<<"\r";
//	wincon.attrib^=3;
	asm sti	//᭥  ᫨  sti
	wincon.digitCount=8;
	wincon<<"return CS:EIP="<<OLD_CS<<':'<<OLD_EIP<<"  ";
	wincon.UpdateCursor();
	wincon.attrib=jjj;
	wincon<<'';
	wincon.attribReset();
	DWORD wtime=1000;
	if (wait_key(1, wtime)) goto Continue;
	if (wait_key(2, wtime)) goto term;
	if (wait_key(10, wtime)) goto set_trace;
	if (wait_key(12, wtime)) { OLD_EIP--;
		beep(17,7000);
		beep(28,6000);
		pause(3000);
		}

	if (wait_key(13,wtime)) { OLD_EIP++;
		beep(18,6000);
		beep(17,7000);
		pause(3000);
		}

  }
  goto Continue;

set_trace:
	if (!TraceMode) OLD_EFLAGS|=256; //????祬 
	goto Continue;

term:
//७ 襭 ணࠬ
	Terminate();

Continue:

	if (ShowDebug) RestoreTextScreenBuffer();

	if (!Auto)
	{
		beep(20,6000);
		beep(20,8000);
		pause(200);
	}
//	else {	  	beep(1,6000);
	//	beep(1,8000);
	//}


//	info[8]=OLD_ESP;

//室  ࠡ稪
	asm {
		pop ax ax	// cs ss ய᪠
		pop gs fs es ds	//   V-०   ॣ =0
						//䠪᪮  祭   ⥪
						//   P-०  
		POPAD
//		pop ebp	// ᯠᥬ  孨 2 , ⠫쭮  १ leave
  //		pop eax	//esp (ய᪠_
	//	pop edi esi edx ecx ebx eax

		leave       // 1) pop sp,bp 2) pop bp
		add sp,4	//  訡
		iretd
	}
}
